int Drehzahl = 605; //Umdrehungen pro Minute
const int AnzahlBlaetter = 5;
boolean Leds[14 + 6];
int ZeitProBlatt; //in us
  //unsigned long Start = 0;
byte Stelle = 0;
boolean RichtungRand = true;

void BerechneWartezeit() {
  float UmdrehungProSekunde = (float)Drehzahl / 60.0;
  ZeitProBlatt = 1.0f / (UmdrehungProSekunde 
               * (float)AnzahlBlaetter) * 1000000.0f;
}

void AlleLoeschen() {
  for (int i = 0; i < 20; i++) {
    Leds[i] = false;
  }
}

void ZeigeLeds() {
  digitalWrite(A5, Leds[0]);
  digitalWrite(A4, Leds[1]);
  digitalWrite(A3, Leds[2]);
  digitalWrite(A2, Leds[3]);
  digitalWrite(A1, Leds[4]);
  digitalWrite(A0, Leds[5]);

  for (int i = 6; i < 14 + 6; i++) {
    digitalWrite(14 - (i - 5), Leds[i]);
  }
}

void setup() {
  //Berechne die Zeit, innerhalb der
  //ein Blatt angezeigt werden soll.
  BerechneWartezeit();
  
  //Setze alle Ausgänge als Ausgang.
  for (int i = 0; i < 14; i++) {
    pinMode(i, OUTPUT);
  }
  pinMode(A0, OUTPUT);
  pinMode(A1, OUTPUT);
  pinMode(A2, OUTPUT);
  pinMode(A3, OUTPUT);
  pinMode(A4, OUTPUT);
  pinMode(A5, OUTPUT);

  //Zum Herausfinden der Drehzahl.
  //  delay(10000);
  //  Start = millis();
}

void loop() {

  //Wird zum Herausfinden der Drehzahl benutzt.
  //  if(millis() - Start > 2000) {
  //    Drehzahl += 10;
  //    BerechneWartezeit();
  //    delay(500);
  //    Start = millis();
  //  }
  
  //Lasse einen Lichtpunkt von außen nach innen
  //und wieder nach außen wandern.
  if(Stelle == 0)
    RichtungRand = true;
  if(Stelle == 19)
    RichtungRand = false;
  
  if(RichtungRand) {
    Stelle++;
  }else {
    Stelle--;
  }
  
  AlleLoeschen();      //Schalte alle Leds aus.
  
  Leds[Stelle] = true; //Zeichne ein Blütenblatt.
  //Das Innere Blatt soll nicht überdeckt werden.
  if((19 - Stelle) / 2 > Stelle)
    //Zeichne ein äußeres Blütenblatt.
    Leds[(19 - Stelle) / 2] = true;
  Leds[0] = true;      //Zeichne einen Ring in der Mitte.
  
  ZeigeLeds();         //Schalte die gewünschten Leds ein.
  
  //Warte bis die nächste Position erreicht ist
  delayMicroseconds(ZeitProBlatt / 40);
}

