byte Led[20];
int Zaehler;
#define WECHSEL (60*1000L)    //60 Sekunden
#define HERZSCHLAG (1*1000L)  //1  Sekunde
#define GLUEHEFFEKT 30        //Geschwindigkeit, mit der ein Punkt 
                              //seine Helligkeit verliert
void setup()
{
  for (int i = 0; i <= 19; i++) {
    pinMode(i, OUTPUT);
  }
  LedsAktualisieren(255);
  Zaehler = 255;
}

void LedsAktualisieren(byte wert)
{
  for (int i = 0; i <= 19; i++) {
    Led[i] = wert;
  }
}

void loop()
{
  if (millis() % WECHSEL <= WECHSEL / 2)
  {
    //Herzschlaganimation
    if (millis() % HERZSCHLAG <= 10 )
    {
      //Herzschlag!
      LedsAktualisieren(255);
    }
    if ((millis() % HERZSCHLAG >= HERZSCHLAG / 3 ) &&
        (millis() % HERZSCHLAG <= HERZSCHLAG / 3 + 10))
    {
      LedsAktualisieren(180);
    }

  } else {
    //Wandernder Punkt - Animation
    int aktuelleLed = (millis() % 1000) / 50;
    Led[aktuelleLed] = 255;
  }


  //Software-PWM
  for (int i = 0; i <= 19; i++) {
    if (Led[i] <= Zaehler) {
      digitalWrite(i, LOW);
    } else {
      digitalWrite(i, HIGH);
    }
  }

  Zaehler = Zaehler - GLUEHEFFEKT;  //Helligkeitsabnahme
  if (Zaehler <= 0) {
    for (int i = 0; i <= 19; i++) {
      byte ZwischenWert = Led[i];
      if (ZwischenWert > 0) {
        Led[i] = ZwischenWert - 1;
      }
    }
    Zaehler = 255;
  };
}
